<template>
  <div class="list">
    <AiTopFixed>
      <u-tabs :list="tabList" :is-scroll="false" :current="currentTabs" height="96" bg-color="#3975C6" inactive-color="#fff" active-color="#fff" @change="change"></u-tabs>
      <div class="select-top">
        <div class="tab-item" @click="show = true">
          <span class="color-666">{{girdNameText}}</span>
          <img src="./components/img/down-icon.png" alt="" />
        </div>

        <u-select v-model="show" :list="myGirdList" value-name="id" label-name="girdName" @confirm="confirm"></u-select>

        <div class="tab-item" @click="showType = true">
          <span class="color-666">{{eventStatusText}}</span>
          <img src="./components/img/down-icon.png" alt="" />
        </div>

        <u-select v-model="showType" :list="listType" value-name="dictValue" label-name="dictName" @confirm="confirm"></u-select>
      </div>
    </AiTopFixed>

    <template >
      <AiCard v-for="(item, i) in datas" :key="i" @click.native="goDetail(item, 1)">
        <template #custom>
          <div class="card-top">
            <div class="titles">{{ item.content }}</div>

            <div class="types">
              <span>事件类型</span>
              <span class="types-right">{{ item.groupName }}</span>
            </div>

            <div class="gards">
              <span>所属网格</span>
              <span class="gards-right">{{ item.girdName }}</span>
            </div>
          </div>

          <div class="status" :class="item.eventStatus == 0 ? 'status0' : item.eventStatus == 1 ? 'status1' : item.eventStatus == 2 ? 'status2' : 'status3'" v-if="item.eventStatus">
            <span class="icon"></span>
            <span>
              {{ $dict.getLabel('clapEventStatus', item.eventStatus) }}
            </span>
          </div>
        </template>
      </AiCard>
      <AiEmpty v-if="!datas.length"></AiEmpty>
    </template>

    <div class="pad-b120" v-if="datas.length"></div>
  </div>
</template>

<script>
import { mapState } from 'vuex'

export default {
  props: {},
  data() {
    return {
      datas: [],
      tabList: [
        {
          name: '全部待办',
        },
        {
          name: '办件历史',
        },
      ],
      currentTabs: 0,
      current: 1,
      pages: 0,
      show: false,
      myGirdList: [],
      girdId: '',
      girdNameText: '所属网格',
      showType: false,
      listType: [],
      eventStatus: '',
      eventStatusText: '办件状态',
      listTypeHistory: [],
      listTypeAll: []
    }
  },
  computed: {
    ...mapState(['user']),

    loadmore() {
      return this.pages <= this.current ? 'loading ' : 'nomore'
    },
  },
  mounted() {
    this.current = 1
    this.girdList()
    this.getList()
    uni.$on('nextList', ()=>{
      this.current ++
      this.getList()
    })
    uni.$on('getListInit', ()=>{
      this.current = 1
      this.getList()
    })

  },
  created() {
    this.$dict.load('clapEventStatus', 'clapEventStatusAll', 'clapEventStatusHistory').then(() => {
      this.getList()
      this.listTypeAll = this.$dict.getDict('clapEventStatusAll')
      this.listTypeHistory = this.$dict.getDict('clapEventStatusHistory')
      this.listType = this.listTypeAll
    })
  },
  methods: {
    getList() {
      this.$http
        .post(`/app/appclapeventinfo/listByGirdMember`, null, {
          params: {
            size: 10,
            current: this.current,
            searchType: this.currentTabs == 1 ? '1' : '0',
            eventStatus: this.eventStatus,
            girdId: this.girdId
          },
        })
        .then((res) => {
          if (res.code == 0) {
            this.datas = this.current > 1 ? [...this.datas, ...res.data.records] : res.data.records
            this.pages = res.data.pages
            this.$forceUpdate()
          }
        })
    },

    girdList() {
      this.$http.post(`/app/appgirdmemberinfo/queryMyGirdList`, null, {
        params: {
          size: 9999,
        },
      })
      .then((res) => {
        if (res.code == 0) {
          this.myGirdList = res.data
          var all = {
            id: '',
            girdName: '全部'
          }
          this.myGirdList.unshift(all)
        }
      })
    },

    confirm(e) {
      if (this.show) {
        this.girdNameText = e[0].label
        this.girdId = e[0].value
      }
      if (this.showType) {
        this.eventStatus = e[0].value
        this.eventStatusText = e[0].label
      }

      this.current = 1
      this.getList()
    },

    goDetail(item) {
      uni.navigateTo({ url: `./Detail?id=${item.id}` })
    },

    change(index) {
      this.current = 1
      this.datas = []
      this.eventStatus = ''
      this.girdId = ''
      this.girdNameText = '所属网格'
      this.eventStatusText = '办件状态'
      this.currentTabs = index
      if(index == 0) {
        this.listType = this.listTypeAll
      }else {
        this.listType = this.listTypeHistory
      }
      this.getList()
    },

    linkTo(url) {
      uni.navigateTo({ url })
    },
  },
}
</script>

<style scoped lang="scss">
uni-page-body {
  height: 100%;
}
.list {
  height: 100%;
  .select-top {
    background: #fff;
    display: flex;
    padding: 24px 0;
    .tab-item {
      flex: 1;
      text-align: center;
      line-height: 48px;
      font-size: 26px;
      font-family: PingFangSC-Regular, PingFang SC;
      color: #666;
      img {
        width: 32px;
        height: 32px;
        margin-left: 8px;
        vertical-align: middle;
      }
    }
    .tab-item:nth-of-type(1) {
      border-right: 1px solid #eee;
    }
  }
  ::v-deep .AiTopFixed .content {
    padding: 0;
  }
  ::v-deep .AiCard {
    background: #f3f6f9;
    padding: 24px 40px 0 32px;
    .start {
      background: #fff;
      border-radius: 16px;
      .card-top {
        padding: 32px;
        .titles {
          margin-bottom: 34px;
          font-size: 32px;
          font-weight: 500;
          color: #333333;
          line-height: 1.4;
          word-break: break-all;
          overflow: hidden;
          text-overflow: ellipsis;
          display: -webkit-box;
          -webkit-line-clamp: 2;
          -webkit-box-orient: vertical;
        }
        .types,
        .gards {
          margin-top: 8px;
          font-size: 26px;
          .types-right,
          .gards-right {
            margin-left: 32px;
            color: #333333;
          }
        }
      }

      .status {
        padding: 32px;
        border-top: 1px solid #dddddd;
        .icon {
          display: inline-block;
          width: 8px;
          height: 8px;
          vertical-align: middle;
          margin-right: 8px;
        }
      }

      .status0 {
        color: #ff883c;
        .icon {
          background: #ff883c;
        }
      }

      .status1 {
        color: #1aaaff;
        .icon {
          background: #1aaaff;
        }
      }

      .status2 {
        color: #42d784;
        .icon {
          background: #42d784;
        }
      }

      .status3 {
        color: #ff4466;
        .icon {
          background: #ff4466;
        }
      }
    }
  }
  // ::v-deep .AiCard:last-child {
  //   padding-bottom: 24px;
  // }
  .pad-b120 {
    background-color: #f3f6f9;
    padding-bottom: 120px;
  }
}
</style>
